# -*- coding:Utf-8 -*-

from __future__ import with_statement

import es
import os
import time
import urllib
import cfglib
import zipfile
import usermsg
import playerlib
import gamethread

	
info          = es.AddonInfo()
info.name     = 'Chatbox Titles'
info.version  = '1.0'
info.basename = 'chatbox'
info.author   = 'FMIS @K Menace.'
info.url      = 'http://addons.eventscripts.com/addons/view/47120'
info.dlurl    = 'http://addons.eventscripts.com/addons/download/chatbox/2'

	
CONFIGPATH = (es.getAddonPath(info.basename) + '/configuration.ini').replace('\\','/')
if not os.path.isfile(CONFIGPATH):
	Dir  = es.ServerVar('eventscripts_gamedir') + os.sep
	Path = Dir + 'Chatbox V' + info.version + '.zip'
	Obj = urllib.urlopen(info.dlurl)
	with open(Path, 'wb') as fp:
		fp.write(Obj.read())
	Obj.close()
	time.sleep(2)
	zfobj = zipfile.ZipFile(Path)	
	for name in zfobj.namelist():
		FilePath = os.path.join(Dir, name)
		if FilePath == CONFIGPATH:
			with open(FilePath, 'wb') as outfile:
				outfile.write(zfobj.read(name))
	try: os.remove(Path)

CONFIG = cfglib.AddonINI(CONFIGPATH)

TITRES           = CONFIG['Titres']
ANTIFLOOD        = bool(CONFIG['Configuration']['AntiFlood'])
ADDCOMMAND       = CONFIG['Configuration']['AddCommand']
REMCOMMAND       = CONFIG['Configuration']['RemCommand']
ADMINGROUPS      = CONFIG['Configuration']['AdminGroups']
FILTERCHARS      = CONFIG['Configuration']['FilterChars']
SHOWDEADMSG      = bool(CONFIG['Configuration']['ShowDeadMsg'])
ANTIFLOODTIME    = float(CONFIG['Configuration']['AntiFloodTime'])
FILTERCOMMANDS   = CONFIG['Configuration']['FilterCommands']
DELETEASCIICHARS = bool(CONFIG['Configuration']['DeleteASCIIChars'])

PLAYERTEAMS = {1:'spec', 2:'t', 3:'ct'}

SCRIPTVAR = es.ServerVar('chatbox_version', info.version, 'Version of the Chatbox Titles\'s script by FMIS @k Menace.')
SCRIPTVAR.makepublic()

class TitleManager(object):
	def __init__(self):
		self.players = {}
	
	def checkPlayer(self, steamid):
		return self.players.has_key(steamid)
		
	def addPlayer(self, steamid, title):
		if not self.checkPlayer(steamid):
			if title in TITRES:
				CONFIG.addValueToGroup('Titres', title, TITRES[title] + ', ' + steamid, True)
			else:
				CONFIG.addValueToGroup('Titres', title, steamid, True)
			self.players[steamid] = title
			
	def removePlayer(self, steamid):
		if self.checkPlayer(steamid):
			CONFIG.addValueToGroup('Titres', self.players[steamid], TITRES[self.players[steamid]].replace(steamid + ', ', ''), True)
			del self.players[steamid]
		
	def getPlayersTitle(self):
		for title in TITRES:
			for steamid in TITRES[title].split(', '):
				self.players[steamid] = title

class FloodManager(object):
	def __init__(self):
		self.players = []
		
	def checkPlayer(self, userid):
		return userid in self.players
		
	def addPlayer(self, userid):
		if not self.checkPlayer(userid):
			self.players.append(userid)
			gamethread.delayed(ANTIFLOODTIME, self.removePlayer, userid)
			
	def removePlayer(self, userid):
		if self.checkPlayer(userid):
			self.players.remove(userid)
			
def sayFilter(userid, text, team):
	userid, text, team = int(userid), text.strip('"'), bool(team)
	player = playerlib.getPlayer(userid)
	if es.exists('saycommand', text.split()[0]) or text[0] in FILTERCHARS or text.split()[0] in FILTERCOMMANDS.split(', ') or not tm.checkPlayer(player.steamid):
		return (userid, text, team)
	if ANTIFLOOD:
		if fm.checkPlayer(userid):
			return ('', 0, '')
		fm.addPlayer(userid)
	if DELETEASCIICHARS:
		for char in map(lambda x: chr(x), range(0, 32)):
			if not char in text:
				text = text.replace(char, '')
	target  = '#human' if not team else '#' + PLAYERTEAMS[player.team]
	message = '\5[\4%s\5] \3%s \1: %s' % (tm.players[player.steamid], player.name, text)
	if player.isdead:
		if not SHOWDEADMSG:
			target += ',#dead'
		message = '\3*\1DEAD\3* ' + message
	for uid in playerlib.getUseridList(target):
		usermsg.saytext2(uid, player.index, message)
	return ('', 0, '')
		
def addPlayerTitle():
	args              = es.getargs().split()
	userid, userid2   = es.getuserid(args[1]), es.getcmduserid()
	steamid, steamid2 = es.getplayersteamid(userid), es.getplayersteamid(userid2)
	if not es.exists('userid', userid):
		es.tell(userid2, "Cannot found userid for '" + args[1] + "' sorry.")
		return
	if not tm.checkPlayer(steamid2):
		es.tell(userid2, "You are not titled, so, you can't access to this command")
		return
	if not len(args) >= 2:
		es.tell(userid2, "Syntax : " + ADDCOMMAND + " <userid|part of name|steamid> <title>")
		return
	if not tm.players[steamid2] in ADMINGROUPS:
		es.tell(userid2, "You're not authorized to use this command!")
		return
	if tm.checkPlayer(steamid):
		tm.removePlayer(steamid)
	tm.addPlayer(steamid, args[len(args)-1].replace('_', ''))

def removePlayerTitle():
	args              = es.getargs().split()
	userid, userid2   = es.getuserid(args[1]), es.getcmduserid()
	steamid, steamid2 = es.getplayersteamid(userid), es.getplayersteamid(userid2)
	if not es.exists('userid', userid):
		es.tell(userid2, "Cannot found userid for '" + args[1] + "', sorry.")
		return
	if not tm.checkPlayer(steamid2):
		es.tell(userid2, "You are not titled, so, you can't access to this command")
		return
	if not len(args) >= 2:
		es.tell(userid2, "Syntax : " + ADDCOMMAND + " <userid|part of name|steamid> <title>")
		return
	if not tm.players[steamid2] in ADMINGROUPS:
		es.tell(userid2, "You're not authorized to use this command!")
		return
	if not tm.checkPlayer(steamid):
		es.tell(userid2, "Player '" + es.getplayername(userid) + "' have no title.")
		return
	tm.removePlayer(steamid)
	
def es_map_start(ev):
	tm.getPlayersTitle()
	
def load():  
	es.addons.registerSayFilter(sayFilter)
	es.regsaycmd(ADDCOMMAND, 'mChatbox/addPlayerTitle')
	es.regsaycmd(REMCOMMAND, 'mChatbox/removePlayerTitle')
	tm.getPlayersTitle()
	
def unload():  
	es.addons.unregisterSayFilter(sayFilter)
	es.unregsaycmd(ADDCOMMAND)
	es.unregsaycmd(REMCOMMAND)
	
tm = TitleManager()
fm = FloodManager()